package com.localhost.grok.concurrentcy2;

import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.Bundle;
import android.os.IBinder;
import android.support.design.widget.FloatingActionButton;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.TextView;

import java.util.Random;

public class MainActivity extends AppCompatActivity implements SimpleBinder.MyListener {


    SimpleBinder mBinder;
    boolean mBound = false;
    TextView textField;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        textField =(TextView)findViewById(R.id.resultData);
        FloatingActionButton fab = (FloatingActionButton) findViewById(R.id.fab);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {


               Intent intent = new Intent(getApplicationContext(), SimpleIntentService.class);
                intent.putExtra("link", "url_to_load");
                startService(intent);
              Intent intent2 = new Intent(getApplicationContext(),SimpleService.class);
                Random rn = new Random();

                intent.putExtra("url", "url_to_file"+ rn.nextInt());
                startService(intent2);
                Intent intent3 = new Intent(getApplicationContext(),SimpleQueueService.class);
                startService(intent3);

              Intent intent4 = new Intent(getApplicationContext(),MusicService.class);
                intent.putExtra("filename", "johny_cash-16tons.mp3");
                startService(intent4);
                if (mBound)
                {
                    mBinder.loadData();
                }

            }
        });




    }

    @Override
    protected void onPause() {
        super.onPause();
        mBinder.detach();
        unbindService(mConnection);
        Log.e("service", "unbind");
    }
    public void startSecond(View v)
    {
        Intent intent = new Intent(this,SecondActivity.class);
        startActivity(intent);
        onStop();

    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        // Unbind from the service
        if (mBound) {
            Log.e("Activity", "stop called");
            unbindService(mConnection);
            mBinder.detach();
            mBound = false;
        }

    }

    @Override
    protected void onStart() {
        super.onStart();
        Intent intent = new Intent(this, SimpleBindService.class);
        bindService(intent, mConnection, Context.BIND_AUTO_CREATE);

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    private ServiceConnection mConnection = new ServiceConnection() {

        @Override
        public void onServiceConnected(ComponentName className,
                                       IBinder service) {
            // We've bound to LocalService, cast the IBinder and get LocalService instance
            mBinder = (SimpleBinder) service;
            mBinder.attach(MainActivity.this);
            mBound = true;
            Log.e("service", "service connected");

        }

        @Override
        public void onServiceDisconnected(ComponentName arg0) {
            mBound = false;
        }
    };

    @Override
    public void dataLoaded() {
        if (mBound)
        {
            Log.e("Service", "Main activity: " + mBinder.loadCachedData());
        }
    }
}
