package com.localhost.grok.concurrentcy2;

import android.app.ActivityManager;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.Bundle;
import android.os.IBinder;
import android.support.design.widget.FloatingActionButton;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.widget.TextView;

/**
 * Created by grok on 4/29/16.
 */
public class SecondActivity extends AppCompatActivity implements SimpleBinder.MyListener{

    SimpleBinder mBinder;
    boolean mBound = false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        TextView textView = (TextView)findViewById(R.id.resultData);
        textView.setText("Second activity");
        FloatingActionButton fab = (FloatingActionButton) findViewById(R.id.fab);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

           /*     Boolean isRunned = isMyServiceRunning(SimpleService.class);
                Log.e("service status", " "+isRunned);
                Intent intent = new Intent(getApplicationContext(), SimpleService.class);
                    if(startService(intent) != null) {
                    Log.e("service", "running");
                }
                else {
                    Log.e("service", "not running");
                }*/

                Intent intent = new Intent(getApplicationContext(), SimpleBindService.class);
                bindService(intent, mConnection, Context.BIND_AUTO_CREATE);
                if (mBound)
                {
                    mBinder.loadData();
                }



            }
        });

    }

    @Override
    protected void onStart() {
        super.onStart();


    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        mBinder.detach();
        mBound=false;
        unbindService(mConnection);
    }

    private boolean isMyServiceRunning(Class<?> serviceClass) {
        ActivityManager manager = (ActivityManager) getSystemService(Context.ACTIVITY_SERVICE);
        for (ActivityManager.RunningServiceInfo service : manager.getRunningServices(Integer.MAX_VALUE)) {
            if (serviceClass.getName().equals(service.service.getClassName())) {
                return true;
            }
        }
        return false;
    }


    private ServiceConnection mConnection = new ServiceConnection() {

        @Override
        public void onServiceConnected(ComponentName className,
                                       IBinder service) {
            // We've bound to LocalService, cast the IBinder and get LocalService instance
            mBinder = (SimpleBinder) service;
            mBinder.attach(SecondActivity.this);
            mBound = true;
            Log.e("service", "service connected");
        }

        @Override
        public void onServiceDisconnected(ComponentName arg0) {
            mBound = false;
        }
    };


    @Override
    public void dataLoaded() {

        if (mBound)
        {
            Log.e("Service", "Main activity: " + mBinder.loadCachedData());
        }

    }
}
