package com.localhost.grok.concurrentcy2;

import android.app.IntentService;
import android.app.Notification;
import android.app.PendingIntent;
import android.content.Intent;
import android.os.AsyncTask;
import android.support.v4.app.NotificationCompat;
import android.util.Log;

/**
 * Created by grok on 4/29/16.
 */
public class SimpleIntentService extends IntentService {
    /**
     * Creates an IntentService.  Invoked by your subclass's constructor.
     *
     * @param name Used to name the worker thread, important only for debugging.
     */
    String url;
    public SimpleIntentService() {
        super("service_name");

    }

    @Override
    protected void onHandleIntent(Intent intent) {

        try {
            NotificationCompat.Builder mBuilder=
                    new NotificationCompat.Builder(this)
                            .setSmallIcon(R.mipmap.
                                            ic_launcher
                            )
                            .setContentTitle("Notification message")
                            .setContentText("Text for user");
            Intent notificationIntent = new Intent(this, MainActivity.class);

            PendingIntent pendingIntent = PendingIntent.getActivity(this, 0, notificationIntent, 0);
            mBuilder.setContentIntent(pendingIntent);
            Notification fullNotif = mBuilder.build();
            startForeground(42, fullNotif);

            String url=intent.getStringExtra("link");
            Thread.sleep(5000);
            Log.e("IntentService", "data loaded to" + url);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }



    }


    private static class MyLoader extends AsyncTask<String, Void, Void>
    {

        @Override
        protected Void doInBackground(String... params) {
            try {
                Thread.sleep(5000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(Void aVoid) {
            Log.e("IntentService", "here!");
            super.onPostExecute(aVoid);
        }
    }
}
